#!/usr/bin/python
import cgitb
cgitb.enable()
print "Content-Type: text/html;charset=utf-8"
print

# Ask the form to extract parameters from the request
import cgi
form = cgi.FieldStorage()

# Print out those parameters, just so that we could see what's happening
print "<pre>"
print "<b>The parameters provided by the user:</b>"
print
for name in form.keys() :
   print name, "=", form[name].value
print

# Connect to the database

import MySQLdb
config = "/home/kenobio1/.my.cnf"
db = MySQLdb.connect(db="starwars",
       read_default_file=config)
cursor=db.cursor()

# Setup the query template
TEMPLATE = """
select * from persona
where species = '%s' and gender = '%s';
"""

# Print it out, so that we know what's going on
print "<b>The query template:</b>"
print TEMPLATE

# If the desired fields are provided, let's use them
if form.has_key("species") and  form.has_key("gender"):
  # Get the value for 'species' parameter from the form
  species = form["species"].value
  # Escape it to avoid mischief
  species = db.escape_string(species)
  # Get the value for 'gender' parameter from the form
  gender = form["gender"].value
  # Escape it to avoid mischief
  gender = db.escape_string(gender)

  # Fill in the query with the values supplied by the user  
  query = TEMPLATE % (species, gender)

  # Print out the filled-in query so that we know what's going on
  print "<b>The filled-in query:</b>"
  print query
  print "</pre>"

  # Now we can actually send the query to the database
  print "<h1>The results of the query</h1>"

  # Tell the cursor to run the query
  cursor.execute(query);
  # Get the results back as a list
  rows = cursor.fetchall()
  # Start the html table
  print "<table border='1'>"
  # For each row in the list...
  for row in rows:
    # Start an HMTL row
    print "<tr>"
    # For each of the values 0, 1, and 3:
    for i in [0,1,3]:
      # print the value of the corresponding column (in the current row)
      print "<td>", row[i], "</td>"
    print "</tr>"
    # close the HTML row tag and move on to the next row
  print "</table>"
  # done!

else :
  print "Some of the necessary parameters are not set"
